from tkinter import *
from tkinter import messagebox
import random, math, time
import winsound #windowsのみ。他の場合は削除してください

class spark_data:
    def __init__(self,X=0, Y=0,R=0, G=0, B=0, VX=0, VY=0, m=0):
        self.X=X; self.Y=Y; self.VX=VX; self.VY=VY
        self.m=m; self.R=R; self.G =G ; self.B=B
def array(N1, N2=0, N3=0):
    if N2 == 0 and N3==0:
        return [0 for i in range(N1)]
    elif N3 == 0:
        return [[0 for i in range(N2)] for j in range(N1)]
    else:
        return [[[0 for i in range(N3)] for j in range(N2)] for k in range(N1)]
NUMS =30    # 円方向分割数
HMAX =10    # 残像の数
NSTEP =5    # 爆発回数
PI =math.pi
counter=0
sparks=array(NSTEP,NUMS,HMAX)
#■初期設定
def initialize():
    global step,counter, KK,G,myu,DT,tFact, fFact
    step=0; counter=0; KK=5
    G=0.98; myu=0.2; T=0; DT=0.02
    tFact= int(DT*1000); fFact= int(DT*100)
    genSparks()
#■火花の生成    
def genSparks():
    global step, NSTEP,PI, MD,DA,angle, NUMS, HMAX
    if step>=NSTEP: return
    ct=((0xFF, 0, 0), (0, 0xFF, 0xFF), (0xFF, 0xFF, 0), (0xFF, 0, 0xFF), (0, 0, 0xFF))
    MD = step % 5;
    DA=2.0* PI/ float(NUMS); angle=float(MD*2)
    for i in range(NUMS):        
        for j in range(HMAX):
            sparks[step][i][j]=spark_data()
        sparks[step][i][0].R=ct[MD][0]
        sparks[step][i][0].G=ct[MD][1]
        sparks[step][i][0].B=ct[MD][2]
        angle +=DA
        sparks[step][i][0].VX=10*math.cos(angle)  #初期速度
        sparks[step][i][0].VY=-10*math.sin(angle)
    step+=1
#■速度、位置を計算、明るさは徐々に暗くする
def comEq():
    global KK, counter,step,NUMS,HMAX, sparkes,myu,fFact,kFact, DT
    for l in range(KK):
        counter+=1
        if counter % 20 == 0 : genSparks() #カウンタ20回ごとに新しい火の粉生成
        for k in range(step):
            for i in range(NUMS):
                if sparks[k][i][0].R!=0 or sparks[k][i][0].G!=0 or sparks[k][i][0].B!=0:
                    j=HMAX-1
                    while j > 0 : #残像分の移動
                        sparks[k][i][j].X=sparks[k][i][j-1].X
                        sparks[k][i][j].Y=sparks[k][i][j-1].Y
                        
                        sparks[k][i][j].R =sparks[k][i][j-1].R-tFact#徐々に暗く
                        if sparks[k][i][j].R<0: sparks[k][i][j].R=0
                        
                        sparks[k][i][j].G =sparks[k][i][j-1].G-tFact#徐々に暗く
                        if sparks[k][i][j].G<0: sparks[k][i][j].G=0
                        
                        sparks[k][i][j].B =sparks[k][i][j-1].B-tFact#徐々に暗く
                        if sparks[k][i][j].B<0: sparks[k][i][j].B=0
                        j-=1
                    ACY=G-sparks[k][i][0].VY*myu; ACX=-sparks[k][i][0].VX*myu
                    sparks[k][i][0].R -= fFact
                    if sparks[k][i][0].R<0 : sparks[k][i][0].R=0

                    sparks[k][i][0].G -= fFact
                    if sparks[k][i][0].G<0: sparks[k][i][0].G=0

                    sparks[k][i][0].B -= fFact
                    if sparks[k][i][0].B<0 : sparks[k][i][0].B=0

                    sparks[k][i][0].VX += ACX*DT#加速度分
                    sparks[k][i][0].VY += ACY*DT
                    sparks[k][i][0].X += sparks[k][i][0].VX*DT#移動
                    sparks[k][i][0].Y += sparks[k][i][0].VY*DT

def setX(X): return int(X*10+225)
def setY(Y): return int(Y*10+195)
#■火花の表示
def drawFig(canvas):
    canvas.delete("DT")
    global step,NUMS,HMAX, sparks
    iflag=False;
    for k in range(step):
        for i in range(NUMS):
            j=HMAX-1
            while j>=0:
                if sparks[k][i][j].R!=0 or sparks[k][i][j].G!=0 or sparks[k][i][j].B!=0 :
                    iflag=True
                    X0=setX(sparks[k][i][j].X); Y0=setY(sparks[k][i][j].Y)
                    cl="#%02X%02X%02X" %(sparks[k][i][j].R,sparks[k][i][j].G,sparks[k][i][j].B)
                    canvas.create_oval(X0-1, Y0-1, X0+1, Y0+1,fill=cl,outline=cl, tag="DT")
                j -= 1
    return iflag # すべての火花の R/G/B すべてが 0 のとき花火完了
def leftMouseDown(event):
    comEq();iflag=drawFig(canvas)
    if not iflag :
        initialize(); drawFig(canvas);

root=Tk()
root.title("二次元花火のシミュレーション")
canvas=Canvas(root, width=450,height=450,bg='black')
canvas.pack()
initialize()
drawFig(canvas)
root.update()
#canvas.bind("<Button-1>",leftMouseDown)  #画面コピー用マウス
#root.mainloop()

k=0 # windowsのみ。他の場合は削除して下さい
while True:
    k+=1
    if k<=5 : winsound.Beep(280,100) # windowsのみ。他の場合は削除して下さい
    comEq();iflag=drawFig(canvas)
    if not iflag :
        initialize(); drawFig(canvas);
        k=0 # windowsのみ。他の場合は削除して下さい
    root.update()
    time.sleep(0.0001)
